#ifndef lint
static const char rcsid[] =
"@(#) $Header: /cvsroot/nsnam/ns-2/sctp/sctp.cc,v 1.10 2006/06/23 14:28:40 tom_henderson Exp $ (UD/PEL)";
#endif


#include "ip.h"
#include "sctp.h"
#include "flags.h"
#include "random.h"
#include "template.h"

#include "sctpDebug.h"
#include "asconf.h"

#ifdef DMALLOC
#include "dmalloc.h"
#endif


#define MIN(x,y)        (((x)<(y))?(x):(y))
#define MAX(x,y)        (((x)>(y))?(x):(y))

//int hdr_sctp::offset_;


//********************************************************************************
// Communications Protocols Laboratory(CPL) Kyungpook National University(KNU)
// Su-kyung's code
//********************************************************************************
//jsk
// for add/delete address

unsigned int IP_value;
unsigned int  asconfOption = 0;
const char* node1 = NULL;
const char* node2 = NULL;
char* link1 = NULL;


static class SctpHandoverClass : public TclClass
{
public:
  SctpHandoverClass() : TclClass("Agent/SCTP/Asconf") {}
  TclObject* create(int, const char*const*)
  {
    return (new SctpHandoverAgent());
  }
} classSctpHandoverClass;

SctpHandoverAgent::SctpHandoverAgent() : SctpAgent()
{
}

int SctpHandoverAgent::command(int argc, const char*const* argv)
{
  DBG_I(command); // internal check is done to avoid printing if file is unopen!

  double dCurrTime = Scheduler::instance().clock();
  DBG_PL(command, "<time:%f> argc=%d argv[1]=%s"),
    dCurrTime, argc, argv[1] DBG_PR;

  Tcl& oTcl = Tcl::instance();
  Node *opNode = NULL;
  int iNsAddr;
  int iNsPort;
  NsObject *opTarget = NULL;
  NsObject *opLink = NULL;
  int iRetVal;

  if(argc == 2)
    {
      if (strcmp(argv[1], "reset") == 0)
        {
          Reset();
          DBG_X(command);
          return (TCL_OK);
        }
      else if (strcmp(argv[1], "close") == 0)
        {
          Close();
          DBG_X(command);
          return (TCL_OK);
        }
    }
 else if(argc == 3)
    {
      if (strcmp(argv[1], "advance") == 0)
        {
          DBG_X(command);
          return (TCL_OK);
        }
//********************************************************************************
// Communications Protocols Laboratory(CPL) Kyungpook National University(KNU)
// Su-kyung's code
//********************************************************************************

        // for mSCTP
      else if (strcmp(argv[1], "set_primary_address") == 0)
        {

        //  spNewTxDest->eStatus = SCTP_DEST_STATUS_ACTIVE;
        //  GetNextDest(spNewTxDest)->eStatus = SCTP_DEST_STATUS_INACTIVE;

        //  if (iRestart == 1)
        //          Change();


          opNode = (Node *) TclObject::lookup(argv[2]);
          if(opNode == NULL)
            {
              oTcl.resultf("no such object %s", argv[2]);
              return (TCL_ERROR);
            }

          IP_value = opNode->address();   // save address to add
          asconfOption = 2;

          SetPrimary(opNode->address());
          iRetVal = SendAsconf(spPrimaryDest);//spPrimaryDest);


          if(iRetVal == TCL_ERROR)
          {
                fprintf(stderr, "[SctpAgent::command] ERROR:"
                 "%s is not a valid destination\n",argv[2]);
                DBG_X(command);
                return (TCL_ERROR);
           }


           printf("set.....\n\n");
           DBG_X(command);
           return (TCL_OK);

        }

        //************************************//
        //end of command for mSCTP module     //
        //************************************//

      else if (strcmp(argv[1], "set-multihome-core") == 0)
        {
          opCoreTarget = (Classifier *) TclObject::lookup(argv[2]);
          if(opCoreTarget == NULL)
            {
              oTcl.resultf("no such object %s", argv[4]);
              return (TCL_ERROR);
            }
          DBG_X(command);
          return (TCL_OK);
        }
      else if (strcmp(argv[1], "set-primary-destination") == 0)
        {
          opNode = (Node *) TclObject::lookup(argv[2]);
          if(opNode == NULL)
            {
              oTcl.resultf("no such object %s", argv[2]);
              return (TCL_ERROR);
            }
          iRetVal = SetPrimary( opNode->address() );

          if(iRetVal == TCL_ERROR)
            {
              fprintf(stderr, "[SctpAgent::command] ERROR:"
                      "%s is not a valid destination\n", argv[2]);
              DBG_X(command);
              return (TCL_ERROR);
            }
          DBG_X(command);
          return (TCL_OK);
        }
      else if (strcmp(argv[1], "force-source") == 0)
        {
          opNode = (Node *) TclObject::lookup(argv[2]);
          if(opNode == NULL)
            {
              oTcl.resultf("no such object %s", argv[2]);
              return (TCL_ERROR);
            }
          iRetVal = ForceSource( opNode->address() );

          if(iRetVal == TCL_ERROR)
            {
              fprintf(stderr, "[SctpAgent::command] ERROR:"
                      "%s is not a valid source\n", argv[2]);
              DBG_X(command);
              return (TCL_ERROR);
            }
          DBG_X(command);
          return (TCL_OK);
        }
      else if (strcmp(argv[1], "print") == 0)
        {
          if(eTraceAll == TRUE)
            TraceAll();
          else
            TraceVar(argv[2]);
          DBG_X(command);
          return (TCL_OK);
        }
    }
  else if(argc == 4)
    {
      if (strcmp(argv[1], "add-multihome-destination") == 0)
        {
          iNsAddr = atoi(argv[2]);
          iNsPort = atoi(argv[3]);
          AddDestination(iNsAddr, iNsPort);
          DBG_X(command);
          return (TCL_OK);
        }
//********************************************************************************
// Communications Protocols Laboratory(CPL) Kyungpook National University(KNU)
// Su-kyung's code
//********************************************************************************

        // ********************************** //
        //jsk                               // 
        //to add commands for mSCTP module. //
        // ********************************** //
        else if (strcmp(argv[1], "add_ip") == 0)
        {
                opNode = (Node *) TclObject::lookup(argv[2]);
                opLink = (NsObject *) TclObject::lookup(argv[3]);

                if(opNode == NULL)
                {
                        oTcl.resultf("no such object %s", argv[2]);
                        return (TCL_ERROR);
                }

        //      if(opLink == NULL)
          //      {
            //          oTcl.resultf("no such object %s", argv[3]);
             //         return (TCL_ERROR);
              //  }

                node1 = opNode->name();//(const char*) argv[3];


                //strcpy(link1, argv[4]); //
                //link1 = (const char*) opLink;

                //printf("link = %s\n", link1);

                //oTcl.evalf("%s up",argv[4]);
                IP_value = opNode->address();   // save address to add

                asconfOption = 0; //add-ip
                iRetVal = SendAsconf(spPrimaryDest);//spPrimaryDest);

                if(iRetVal == TCL_ERROR)
                {
                        fprintf(stderr, "[SctpAgent::command] ERROR:"
                                "%s is not a valid destination\n",argv[3]);
                        DBG_X(command);
                        return (TCL_ERROR);
                }

                printf("add-ip....\n\n");
                DBG_X(command);
                return (TCL_OK);
        }

      else if (strcmp(argv[1], "del_ip") == 0)
        {
          opNode = (Node *) TclObject::lookup(argv[2]);
          //opLink = (NsObject *) TclObject::lookup(argv[3]);

          if(opNode == NULL)
          {
                oTcl.resultf("no such object %s", argv[2]);
                return (TCL_ERROR);
          }

          node1 = opNode->name();//(const char*) argv[2];
          //strcpy(link1, argv[3]); //link1 = (const char*) opLink;

          IP_value = opNode->address();   // save address to del

          asconfOption = 1; //del-ip
          //HERE IS POINT//
          iRetVal = SendAsconf(spPrimaryDest);

          if(iRetVal == TCL_ERROR)
          {
                fprintf(stderr, "[SctpAgent::command] ERROR:"
                "%s is not a valid destination\n",argv[2]);
                 DBG_X(command);
                 return (TCL_ERROR);
          }

        printf("%lf\n",Scheduler::instance().clock());
          printf("del.....\n\n");
          DBG_X(command);
          return (TCL_OK);
        }

        else if (strcmp(argv[1], "del_ip2") == 0)
        {
          opNode = (Node *) TclObject::lookup(argv[2]);
          //opLink = (NsObject *) TclObject::lookup(argv[3]);

          if(opNode == NULL)
          {
                oTcl.resultf("no such object %s", argv[2]);
                return (TCL_ERROR);
          }

          node1 = opNode->name();//(const char*) argv[2];
          //strcpy(link1, argv[3]); //link1 = (const char*) opLink;

          IP_value = opNode->address();   // save address to del

          asconfOption = 3; //single case
          //HERE IS POINT//
          iRetVal = SendAsconf(spPrimaryDest);

          if(iRetVal == TCL_ERROR)
          {
                fprintf(stderr, "[SctpAgent::command] ERROR:"
                "%s is not a valid destination\n",argv[2]);
                 DBG_X(command);
                 return (TCL_ERROR);
          }

        printf("%lf\n",Scheduler::instance().clock());
          printf("del.....add,change\n\n");
          DBG_X(command);
          return (TCL_OK);
        }


      else if (strcmp(argv[1], "set-destination-lossrate") == 0)
        {
          opNode = (Node *) TclObject::lookup(argv[2]);
          if(opNode == NULL)
            {
              oTcl.resultf("no such object %s", argv[2]);
              return (TCL_ERROR);
            }
          iRetVal = SetLossrate( opNode->address(), atof(argv[3]) );

          if(iRetVal == TCL_ERROR)
            {
              fprintf(stderr, "[SctpAgent::command] ERROR:"
                      "%s is not a valid destination\n", argv[2]);
              DBG_X(command);
              return (TCL_ERROR);
            }
          DBG_X(command);
          return (TCL_OK);
        }
    }
  else if(argc == 6)
    {
      if (strcmp(argv[1], "add-multihome-interface") == 0)
        {
          iNsAddr = atoi(argv[2]);
          iNsPort = atoi(argv[3]);
          opTarget = (NsObject *) TclObject::lookup(argv[4]);
          if(opTarget == NULL)
            {
              oTcl.resultf("no such object %s", argv[4]);
              return (TCL_ERROR);
            }
          opLink = (NsObject *) TclObject::lookup(argv[5]);
          if(opLink == NULL)
            {
              oTcl.resultf("no such object %s", argv[5]);
              return (TCL_ERROR);
            }
          AddInterface(iNsAddr, iNsPort, opTarget, opLink);
          DBG_X(command);
          return (TCL_OK);
        }
    }

  DBG_X(command);
  return (Agent::command(argc, argv));
}



int SctpHandoverAgent::GenChunk(SctpChunkType_E eType, u_char *ucpChunk)
{
  DBG_I(GenChunk);

  double dCurrTime = Scheduler::instance().clock();
  AppData_S *spAppMessage = NULL;
  int iSize = 0;

  DBG_PL(GenChunk, "spSctpTrace=%p"), spSctpTrace DBG_PR;

  switch(eType)
    {
    case SCTP_CHUNK_INIT:
      iSize = sizeof(SctpInitChunk_S);
      ((SctpInitChunk_S *) ucpChunk)->sHdr.ucType = eType;
      ((SctpInitChunk_S *) ucpChunk)->uiArwnd = uiInitialRwnd;
      ((SctpInitChunk_S *) ucpChunk)->usNumOutboundStreams = uiNumOutStreams;
      ((SctpInitChunk_S *) ucpChunk)->uiInitialTsn = 0;

      ((SctpInitChunk_S *) ucpChunk)->sUnrelStream.usType
        = SCTP_INIT_PARAM_UNREL;

      ((SctpInitChunk_S *) ucpChunk)->sUnrelStream.usLength
        = sizeof(SctpUnrelStreamsParam_S);

      if(uiNumUnrelStreams > 0)
        {
          ((SctpInitChunk_S *) ucpChunk)->sUnrelStream.usLength
            += sizeof(SctpUnrelStreamPair_S);

          SctpUnrelStreamPair_S *spUnrelStreamPair
            = (SctpUnrelStreamPair_S *) (ucpChunk+iSize);
          spUnrelStreamPair->usStart = 0;
          spUnrelStreamPair->usEnd = uiNumUnrelStreams - 1;

          iSize += sizeof(SctpUnrelStreamPair_S);
        }

      ((SctpInitChunk_S *) ucpChunk)->sHdr.usLength = iSize;

      /* fill in tracing fields too
       */
      spSctpTrace[uiNumChunks].eType = eType;
      spSctpTrace[uiNumChunks].uiTsn = (u_int) -1;
      spSctpTrace[uiNumChunks].usStreamId = (u_short) -1;
      spSctpTrace[uiNumChunks].usStreamSeqNum = (u_short) -1;
      break;

    case SCTP_CHUNK_INIT_ACK:
      iSize = sizeof(SctpInitAckChunk_S);
      ((SctpInitAckChunk_S *) ucpChunk)->sHdr.ucType = eType;
      ((SctpInitAckChunk_S *) ucpChunk)->uiArwnd = uiInitialRwnd;
      ((SctpInitChunk_S *) ucpChunk)->usNumOutboundStreams = uiNumOutStreams;
      ((SctpInitAckChunk_S *) ucpChunk)->uiInitialTsn = 0;

      ((SctpInitAckChunk_S *) ucpChunk)->sUnrelStream.usType
        = SCTP_INIT_PARAM_UNREL;

      ((SctpInitAckChunk_S *) ucpChunk)->sUnrelStream.usLength
        = sizeof(SctpUnrelStreamsParam_S);

      if(uiNumUnrelStreams > 0)
        {
          ((SctpInitAckChunk_S *) ucpChunk)->sUnrelStream.usLength
            += sizeof(SctpUnrelStreamPair_S);

          SctpUnrelStreamPair_S *spUnrelStreamPair
            = (SctpUnrelStreamPair_S *) (ucpChunk+iSize);
          spUnrelStreamPair->usStart = 0;
          spUnrelStreamPair->usEnd = uiNumUnrelStreams - 1;

          iSize += sizeof(SctpUnrelStreamPair_S);
        }

      ((SctpInitAckChunk_S *) ucpChunk)->sHdr.usLength = iSize;

      /* fill in tracing fields too
       */
      spSctpTrace[uiNumChunks].eType = eType;
      spSctpTrace[uiNumChunks].uiTsn = (u_int) -1;
      spSctpTrace[uiNumChunks].usStreamId = (u_short) -1;
      spSctpTrace[uiNumChunks].usStreamSeqNum = (u_short) -1;
      break;

    case SCTP_CHUNK_COOKIE_ECHO:
      iSize = sizeof(SctpCookieEchoChunk_S);
      ((SctpCookieEchoChunk_S *) ucpChunk)->sHdr.ucType = eType;
      ((SctpCookieEchoChunk_S *) ucpChunk)->sHdr.usLength = iSize;

      /* fill in tracing fields too
       */
      spSctpTrace[uiNumChunks].eType = eType;
      spSctpTrace[uiNumChunks].uiTsn = (u_int) -1;
      spSctpTrace[uiNumChunks].usStreamId = (u_short) -1;
      spSctpTrace[uiNumChunks].usStreamSeqNum = (u_short) -1;
      break;

    case SCTP_CHUNK_COOKIE_ACK:
      iSize = sizeof(SctpCookieAckChunk_S);
      ((SctpCookieAckChunk_S *) ucpChunk)->sHdr.ucType = eType;
      ((SctpCookieAckChunk_S *) ucpChunk)->sHdr.usLength = iSize;

      /* fill in tracing fields too
       */
      spSctpTrace[uiNumChunks].eType = eType;
      spSctpTrace[uiNumChunks].uiTsn = (u_int) -1;
      spSctpTrace[uiNumChunks].usStreamId = (u_short) -1;
      spSctpTrace[uiNumChunks].usStreamSeqNum = (u_short) -1;
      break;

    case SCTP_CHUNK_DATA:
      /* Depending on eDataSource, we either use chunk parameters 
       * from the app layer buffer, or use the defaults for infinite 
       * data generation.
       */
      if(eDataSource == DATA_SOURCE_APPLICATION)
        {
          /* If DATA_SOURCE_APPLICATION, we have to get chunk parameters
           * from the app layer buffer 
           */
          DBG_PL (GenChunk, "eDataSource=DATA_SOURCE_APPLICATION") DBG_PR;
          spAppMessage = (AppData_S *) (sAppLayerBuffer.spHead->vpData);

          DBG_PL (GenChunk, "App Message ---------------->") DBG_PR;
          DBG_PL (GenChunk, "usNumStreams: %d"),
            spAppMessage->usNumStreams DBG_PR;
          DBG_PL (GenChunk, "usNumUnreliable: %d"),
            spAppMessage->usNumUnreliable DBG_PR;
          DBG_PL (GenChunk, "uiNumBytes: %d"),
            spAppMessage->uiNumBytes DBG_PR;
          DBG_PL (GenChunk, "usStreamId: %d"),
            spAppMessage->usStreamId DBG_PR;
          DBG_PL (GenChunk, "eUnordered: %s"),
            spAppMessage->eUnordered ? "TRUE" : "FALSE" DBG_PR;
          DBG_PL (GenChunk, "usReliability: %d"),
            spAppMessage->usReliability DBG_PR;
          DBG_PL (GenChunk, "App Message <----------------") DBG_PR;

          iSize = spAppMessage->uiNumBytes + sizeof(SctpDataChunkHdr_S);
          ((SctpDataChunkHdr_S *) ucpChunk)->sHdr.ucType = SCTP_CHUNK_DATA;
          ((SctpDataChunkHdr_S *) ucpChunk)->sHdr.usLength = iSize;

          /* DATA chunks must be padded to a 4 byte boundary (section 3.3.1)
           * ...but the adjustment should happen after usLength field is set,
           * because the field should represent the size before padding.
           */
          if( (iSize % 4) != 0)
            iSize += 4 - (iSize % 4);

          ((SctpDataChunkHdr_S *) ucpChunk)->uiTsn = ++uiNextTsn;

          ((SctpDataChunkHdr_S *) ucpChunk)->usStreamId
            = spAppMessage->usStreamId;

          if(spAppMessage->eUnordered == TRUE)
            {
              ((SctpDataChunkHdr_S *) ucpChunk)->sHdr.ucFlags
                |= SCTP_DATA_FLAG_UNORDERED;

              /* no stream seq num on unordered chunks!
               */
            }
          else
            {
              ((SctpDataChunkHdr_S *) ucpChunk)->sHdr.ucFlags = 0;
              ((SctpDataChunkHdr_S *) ucpChunk)->usStreamSeqNum
                = spOutStreams[spAppMessage->usStreamId].usNextStreamSeqNum++;
            }
        }
      else
        {
          DBG_PL (GenChunk, "eDataSource=DATA_SOURCE_INFINITE") DBG_PR;

          iSize = uiDataChunkSize;
          ((SctpDataChunkHdr_S *) ucpChunk)->sHdr.ucType = SCTP_CHUNK_DATA;

          if(eUnordered == TRUE)
            {
              ((SctpDataChunkHdr_S *) ucpChunk)->sHdr.ucFlags
                |= SCTP_DATA_FLAG_UNORDERED;
            }
          else
            {
              ((SctpDataChunkHdr_S *) ucpChunk)->sHdr.ucFlags = 0;
            }

          ((SctpDataChunkHdr_S *) ucpChunk)->sHdr.usLength = iSize;

          /* DATA chunks must be padded to a 4 byte boundary (section 3.3.1)
           * ...but the adjustment should happen after usLength field is set,
           * because the field should represent the size before padding.
           */
          if( (uiDataChunkSize % 4) != 0)
            iSize += 4 - (uiDataChunkSize % 4);

          ((SctpDataChunkHdr_S *) ucpChunk)->uiTsn = ++uiNextTsn;

          ((SctpDataChunkHdr_S *) ucpChunk)->usStreamId
            = (usNextStreamId % uiNumOutStreams);

          if(eUnordered == TRUE)
            {
              ((SctpDataChunkHdr_S *) ucpChunk)->sHdr.ucFlags
                |= SCTP_DATA_FLAG_UNORDERED;

              /* no stream seq num on unordered chunks!
               */
            }
          else
            {
              ((SctpDataChunkHdr_S *) ucpChunk)->sHdr.ucFlags = 0;
              ((SctpDataChunkHdr_S *) ucpChunk)->usStreamSeqNum
                = spOutStreams[usNextStreamId%uiNumOutStreams].usNextStreamSeqNum++;
            }

          usNextStreamId++; // round-robin stream feeding
        }

      /* fill in tracing fields too
       */
      spSctpTrace[uiNumChunks].eType = eType;
      spSctpTrace[uiNumChunks].uiTsn = ((SctpDataChunkHdr_S *) ucpChunk)->uiTsn;
      spSctpTrace[uiNumChunks].usStreamId
        = ((SctpDataChunkHdr_S *) ucpChunk)->usStreamId;
      spSctpTrace[uiNumChunks].usStreamSeqNum
        = ((SctpDataChunkHdr_S *) ucpChunk)->usStreamSeqNum;

      DBG_PL(GenChunk, "DataTsn=%d at dCurrTime=%f"),
        uiNextTsn, dCurrTime DBG_PR;
      break;

    case SCTP_CHUNK_SACK:
      iSize = sizeof(SctpSackChunk_S);
      ((SctpSackChunk_S *) ucpChunk)->sHdr.ucType = eType;
      ((SctpSackChunk_S *) ucpChunk)->uiCumAck = uiCumAck;
      ((SctpSackChunk_S *) ucpChunk)->uiArwnd = uiMyRwnd;
      ((SctpSackChunk_S *) ucpChunk)->usNumGapAckBlocks
        = sRecvTsnBlockList.uiLength;
      ((SctpSackChunk_S *) ucpChunk)->usNumDupTsns = sDupTsnList.uiLength;

      DBG_PL(GenChunk, "SACK CumAck=%d arwnd=%d"), uiCumAck, uiMyRwnd DBG_PR;

      /* Append all the Gap Ack Blocks
       */
      for(Node_S *spCurrFrag = sRecvTsnBlockList.spHead;
          (spCurrFrag != NULL) &&
            (iSize + sizeof(SctpGapAckBlock_S) < uiMaxDataSize);
          spCurrFrag = spCurrFrag->spNext, iSize += sizeof(SctpGapAckBlock_S) )
        {
          SctpGapAckBlock_S *spGapAckBlock
            = (SctpGapAckBlock_S *) (ucpChunk+iSize);

          spGapAckBlock->usStartOffset
            = ((SctpRecvTsnBlock_S *)spCurrFrag->vpData)->uiStartTsn - uiCumAck;

          spGapAckBlock->usEndOffset
            = ((SctpRecvTsnBlock_S *)spCurrFrag->vpData)->uiEndTsn - uiCumAck;

          DBG_PL(GenChunk, "GapAckBlock StartOffset=%d EndOffset=%d"),
            spGapAckBlock->usStartOffset, spGapAckBlock->usEndOffset DBG_PR;
        }

      /* Append all the Duplicate TSNs
       */
      for(Node_S *spPrevDup = NULL, *spCurrDup = sDupTsnList.spHead;
          (spCurrDup != NULL) &&
            (iSize + sizeof(SctpDupTsn_S) < uiMaxDataSize);
          spPrevDup = spCurrDup, spCurrDup = spCurrDup->spNext,
            DeleteNode(&sDupTsnList, spPrevDup), iSize += sizeof(SctpDupTsn_S) )
        {
          SctpDupTsn_S *spDupTsn = (SctpDupTsn_S *) (ucpChunk+iSize);

          spDupTsn->uiTsn = ((SctpDupTsn_S *) spCurrDup->vpData)->uiTsn;

          DBG_PL(GenChunk, "DupTsn=%d"), spDupTsn->uiTsn DBG_PR;
        }

      /* After all the dynamic appending, we can NOW fill in the chunk size!
       */
      ((SctpSackChunk_S *) ucpChunk)->sHdr.usLength = iSize;

      /* fill in tracing fields too
       */
      spSctpTrace[uiNumChunks].eType = eType;
      spSctpTrace[uiNumChunks].uiTsn = ((SctpSackChunk_S *) ucpChunk)->uiCumAck;
      spSctpTrace[uiNumChunks].usStreamId = (u_short) -1;
      spSctpTrace[uiNumChunks].usStreamSeqNum = (u_short) -1;
      break;

    case SCTP_CHUNK_FORWARD_TSN:
      iSize = SCTP_CHUNK_FORWARD_TSN_LENGTH;
      ((SctpForwardTsnChunk_S *) ucpChunk)->sHdr.ucType = eType;
      ((SctpForwardTsnChunk_S *) ucpChunk)->sHdr.ucFlags = 0; // flags not used?
      ((SctpForwardTsnChunk_S *) ucpChunk)->sHdr.usLength = iSize;
      ((SctpForwardTsnChunk_S *) ucpChunk)->uiNewCum = uiAdvancedPeerAckPoint;

      /* fill in tracing fields too
       */
      spSctpTrace[uiNumChunks].eType = eType;
      spSctpTrace[uiNumChunks].uiTsn = uiAdvancedPeerAckPoint;
      spSctpTrace[uiNumChunks].usStreamId = (u_short) -1;
      spSctpTrace[uiNumChunks].usStreamSeqNum = (u_short) -1;
      break;

    case SCTP_CHUNK_HB:
    case SCTP_CHUNK_HB_ACK:
      iSize = SCTP_CHUNK_HEARTBEAT_LENGTH;
      ((SctpHeartbeatChunk_S *) ucpChunk)->sHdr.ucType = eType;
      ((SctpHeartbeatChunk_S *) ucpChunk)->sHdr.ucFlags = 0;
      ((SctpHeartbeatChunk_S *) ucpChunk)->sHdr.usLength = iSize;
      ((SctpHeartbeatChunk_S *) ucpChunk)->usInfoType = 1;
      ((SctpHeartbeatChunk_S *) ucpChunk)->usInfoLength
        = iSize - sizeof(SctpChunkHdr_S);
      ((SctpHeartbeatChunk_S *) ucpChunk)->dTimestamp = dCurrTime;
      ((SctpHeartbeatChunk_S *) ucpChunk)->spDest = NULL; // caller sets dest

      /* fill in tracing fields too
       */
      spSctpTrace[uiNumChunks].eType = eType;
      spSctpTrace[uiNumChunks].uiTsn = (u_int) -1;
      spSctpTrace[uiNumChunks].usStreamId = (u_short) -1;
      spSctpTrace[uiNumChunks].usStreamSeqNum = (u_short) -1;
      break;

//********************************************************************************
// Communications Protocols Laboratory(CPL) Kyungpook National University(KNU)
// Su-kyung's code
//********************************************************************************

    case SCTP_CHUNK_ASCONF:
    case SCTP_CHUNK_ASCONF_ACK:
        printf("making chunk....\n");
        iSize = sizeof(SctpAsconfChunk_S);
        ((SctpAsconfChunk_S *) ucpChunk)-> sHdr.ucType = eType;
        ((SctpAsconfChunk_S *) ucpChunk)-> sHdr.ucFlags = 0;
        ((SctpAsconfChunk_S *) ucpChunk)-> sHdr.usLength = iSize;

        ((SctpAsconfChunk_S *) ucpChunk)-> uiSeriNum = (u_int) -1;
        ((SctpAsconfChunk_S *) ucpChunk)-> uiAddrParam = 0;
        ((SctpAsconfChunk_S *) ucpChunk)-> usType = asconfOption;
        ((SctpAsconfChunk_S *) ucpChunk)-> usLength = iSize - sizeof(SctpChunkHdr_S);
        ((SctpAsconfChunk_S *) ucpChunk)-> uiAsconfReqCorID = (u_int) - 1;
        ((SctpAsconfChunk_S *) ucpChunk)-> uiIpValue = IP_value;
        ((SctpHeartbeatChunk_S *) ucpChunk)->spDest = NULL; // caller sets dest

        /* fill in tracing fields too
       */
      spSctpTrace[uiNumChunks].eType = eType;
      spSctpTrace[uiNumChunks].uiTsn = (u_int) -1;
      spSctpTrace[uiNumChunks].usStreamId = (u_short) -1;
      spSctpTrace[uiNumChunks].usStreamSeqNum = (u_short) -1;
      break;
    //


    case SCTP_CHUNK_SHUTDOWN:
      break;

    case SCTP_CHUNK_SHUTDOWN_ACK:
      break;

    case SCTP_CHUNK_SHUTDOWN_COMPLETE:
      break;

    default:
      fprintf(stderr, "[GenChunk] ERROR: bad chunk type!\n");
      DBG_PL(GenChunk, "ERROR: bad chunk type!") DBG_PR;
      DBG_PL(GenChunk, "exiting...") DBG_PR;
      exit(-1);
    }

  uiNumChunks++;

  DBG_X(GenChunk);
  return iSize;
}




int SctpHandoverAgent::ProcessAsconfAckChunk(SctpAsconfAckChunk_S *spAsconfAckChunk)
{
  Tcl& oTcl = Tcl::instance();
  unsigned int option;
  option = spAsconfAckChunk->usType;

  double dCurrTime = Scheduler::instance().clock();

  printf("recv ASCONF ACK\n");
  if(option == 0)
  {
     //for msctp_test
     oTcl.eval("$l1 up");
     oTcl.evalf("$ns rtmodel-at %lf up $h0_if1 $h1_if1",dCurrTime);
     oTcl.eval("$l1 color black");

     /* for single_homing
     oTcl.eval("$l2 up");
     oTcl.evalf("$ns rtmodel-at %lf up $r2 $mn", dCurrTime);
     oTcl.eval("l2 color black");
*/
     printf("add-ip ok\n\n\n");
     DBG_X(ProcessAsconfAckChunk);
     return(TCL_OK);
  }

  else if(option == 1)
  {
        //for msctp_test
        oTcl.eval("$l0 down");
        oTcl.evalf("$ns rtmodel-at %lf down $h0_if0 $h1_if0", dCurrTime);
        oTcl.eval("$l0 color gray");


        /*// for single_homing
        oTcl.eval("$l1 down");
        oTcl.evalf("$ns rtmodel-at %lf down $r1 $mn", dCurrTime);
        oTcl.eval("l1 color red");
*/
        printf("del-ip ok\n\n\n");
        DBG_X(ProcessAsconfAckChunk);
        return(TCL_OK);

  }

  else if(option == 2)
  {
        //for msctp_test
        oTcl.eval("$sctp0 set restart_ 1");
        oTcl.eval("$sctp0 set-primary-destination $h1_if1");
        oTcl.eval("$sctp1 set-primary-destination $h0_if1");
        //Reset();
        //for single_homing

        //oTcl.eval("$sctp0 set-primary-destination $mn");
        //oTcl.eval("$sctp1 set-primary-destination $cn");
        printf("set-primary-address ok\n\n\n");
        DBG_X(ProcessAsconfAckChunk);
        return(TCL_OK);

  }
  //for single test.. 
  //del-change-add(2.6sec later) 
  else if(option == 3)
  {
        //del
        oTcl.eval("$l0 down");
        oTcl.evalf("$ns rtmodel-at %lf down $h0_if0 $h1_if0", dCurrTime);
        oTcl.eval("$l0 color gray");


        //add,change for single case

        oTcl.eval("$l1 color black");
        oTcl.eval("$sctp0 set-primary-destination $h1_if1");
        oTcl.eval("$sctp1 set-primary-destination $h0_if1");

        printf("single.. del-ip ok\n\n\n");
        DBG_X(ProcessAsconfAckChunk);
        return(TCL_OK);

  }



  else
  {
        printf("can't read asconf option!\n");
        DBG_X(ProcessAsconfAckChunk);
     return(TCL_ERROR);
  }
}
//


int SctpHandoverAgent::ProcessChunk(u_char *ucpInChunk, u_char **ucppOutData)
{
  DBG_I(ProcessChunk);
  int iThisOutDataSize = 0;
  Node_S *spCurrNode = NULL;
  SctpDest_S *spCurrDest = NULL;
  double dCurrTime = Scheduler::instance().clock();
  double dTime;
  SctpHeartbeatAckChunk_S *spHeartbeatChunk = NULL;
  SctpHeartbeatAckChunk_S *spHeartbeatAckChunk = NULL;

//********************************************************************************
// Communications Protocols Laboratory(CPL) Kyungpook National University(KNU)
// Su-kyung's code
//********************************************************************************

  //jsk
  //for processing Asconf/Asconf-Ack chunk...
  SctpAsconfChunk_S *spAsconfChunk = NULL;
  SctpAsconfAckChunk_S *spAsconfAckChunk = NULL;

/*      if(eState !=2)
        {
                printf("eState dosen't match : %d\n",eState);
                printf("%lf\n",Scheduler::instance().clock());
        }
 */

  switch(eState)
    {
    case SCTP_STATE_CLOSED:
      switch( ((SctpChunkHdr_S *)ucpInChunk)->ucType)
        {
        case SCTP_CHUNK_INIT:
          DBG_PL(ProcessChunk, "got INIT!! ...sending INIT_ACK") DBG_PR;
          ProcessInitChunk(ucpInChunk);
          iThisOutDataSize = GenChunk(SCTP_CHUNK_INIT_ACK, *ucppOutData);
          *ucppOutData += iThisOutDataSize;
          /* stay in the closed state */
          break;

        case SCTP_CHUNK_COOKIE_ECHO:
          DBG_PL(ProcessChunk,
                 "got COOKIE_ECHO!! (established!) ...sending COOKIE_ACK")
            DBG_PR;
          ProcessCookieEchoChunk( (SctpCookieEchoChunk_S *) ucpInChunk );
          iThisOutDataSize = GenChunk(SCTP_CHUNK_COOKIE_ACK, *ucppOutData);
          *ucppOutData += iThisOutDataSize;
          eState = SCTP_STATE_ESTABLISHED;
          if(eOneHeartbeatTimer == TRUE && uiHeartbeatInterval != 0)
            {
              dTime = CalcHeartbeatTime(spPrimaryDest->dRto);
              opHeartbeatGenTimer->force_cancel();
              opHeartbeatGenTimer->resched(dTime);
              opHeartbeatGenTimer->dStartTime = dCurrTime;

              for(spCurrNode = sDestList.spHead;
                  spCurrNode != NULL;
                  spCurrNode = spCurrNode->spNext)
                {
                  spCurrDest = (SctpDest_S *) spCurrNode->vpData;
                  spCurrDest->dIdleSince = dCurrTime;
                }
            }
          else if(uiHeartbeatInterval != 0)
            {
              for(spCurrNode = sDestList.spHead;
                  spCurrNode != NULL;
                  spCurrNode = spCurrNode->spNext)
                {
                  spCurrDest = (SctpDest_S *) spCurrNode->vpData;
                  DBG_PL(Reset, "about to calculate HB time for dest=%p"),
                    spCurrDest DBG_PR;
                  dTime = CalcHeartbeatTime(spCurrDest->dRto);
                  spCurrDest->opHeartbeatGenTimer->resched(dTime);
                }
            }
          break;

        default:
          /* ALC 1/25/2002
           *
           * no error statement here, because there are times when this could
           * occur due to abrupt disconnections via the "reset" command. how?
           * well, "reset" resets all the association state. however, there may
           * still be packets in transit. if and when those packets arrive, they
           * will be unexpected packets since the association is closed. since
           * this is a simulation, it shouldn't be a problem. however, if an 
           * application needs a more graceful shutdown, we would need to 
           * implement sctp's proper shutdown procedure. until the need arises,
           * we won't do it. instead, what do we do? ignore the "unexpected"
           * packet.
           */
          DBG_PL(ProcessChunk, "association closed... ignoring chunk %s"),
            "(not COOKIE_ECHO or INIT)" DBG_PR;
          break;
        }
      break;

    case SCTP_STATE_COOKIE_WAIT:
      DBG_PL(ProcessChunk, "got INIT_ACK!! ...sending COOKIE_ECHO") DBG_PR;
      ProcessInitAckChunk(ucpInChunk);
      iThisOutDataSize = GenChunk(SCTP_CHUNK_COOKIE_ECHO, *ucppOutData);
      *ucppOutData += iThisOutDataSize;
      opT1CookieTimer->resched(spPrimaryDest->dRto);
      eState = SCTP_STATE_COOKIE_ECHOED;
      break;

    case SCTP_STATE_COOKIE_ECHOED:
      DBG_PL(ProcessChunk, "got COOKIE_ACK!! (established!) ...sending DATA")
        DBG_PR;
      ProcessCookieAckChunk( (SctpCookieAckChunk_S *) ucpInChunk );
      eSendNewDataChunks = TRUE;
      eState = SCTP_STATE_ESTABLISHED;
      if(eOneHeartbeatTimer == TRUE && uiHeartbeatInterval != 0)
        {
          dTime = CalcHeartbeatTime(spPrimaryDest->dRto);
          opHeartbeatGenTimer->force_cancel();
          opHeartbeatGenTimer->resched(dTime);
          opHeartbeatGenTimer->dStartTime = dCurrTime;

          for(spCurrNode = sDestList.spHead;
              spCurrNode != NULL;
              spCurrNode = spCurrNode->spNext)
            {
              spCurrDest = (SctpDest_S *) spCurrNode->vpData;
              spCurrDest->dIdleSince = dCurrTime;
            }
        }
      else if(uiHeartbeatInterval != 0)
        {
          for(spCurrNode = sDestList.spHead;
              spCurrNode != NULL;
              spCurrNode = spCurrNode->spNext)
            {
              spCurrDest = (SctpDest_S *) spCurrNode->vpData;
              DBG_PL(Reset, "about to calculate HB time for dest=%p"),
                spCurrDest DBG_PR;
              dTime = CalcHeartbeatTime(spCurrDest->dRto);
              spCurrDest->opHeartbeatGenTimer->resched(dTime);
            }
        }
      break;

    case SCTP_STATE_ESTABLISHED:
      switch( ((SctpChunkHdr_S *)ucpInChunk)->ucType)
        {
        case SCTP_CHUNK_DATA:
          DBG_PL(ProcessChunk, "got DATA (TSN=%d)!!"),
            ((SctpDataChunkHdr_S *)ucpInChunk)->uiTsn DBG_PR;

          if(eUseDelayedSacks == FALSE) // are we doing delayed sacks?
            {
              /* NO, so generate sack immediately!
               */
              eSackChunkNeeded = TRUE;
            }
          else  // we are doing delayed sacks, so...
            {
              /* rfc2960 section 6.2 - determine if a SACK will be generated
               */
              if(eStartOfPacket == TRUE)
                {
                  eStartOfPacket = FALSE;  // reset
                  iDataPktCountSinceLastSack++;

                  if(iDataPktCountSinceLastSack == 1)
                    {
                      opSackGenTimer->resched(dSackDelay);
                    }
                  else if(iDataPktCountSinceLastSack == DELAYED_SACK_TRIGGER)
                    {
                      iDataPktCountSinceLastSack = 0; // reset
                      opSackGenTimer->force_cancel();
                      eSackChunkNeeded = TRUE;
                    }
                }
            }

          ProcessDataChunk( (SctpDataChunkHdr_S *) ucpInChunk );

          /* section 6.7 - There is at least one "gap in the received DATA
           * chunk sequence", so let's ensure we send a SACK immediately!
           */
          if(sRecvTsnBlockList.uiLength > 0)
            {
              iDataPktCountSinceLastSack = 0; // reset
              opSackGenTimer->force_cancel();
              eSackChunkNeeded = TRUE;
            }

          /* no state change 
           */
          break;

        case SCTP_CHUNK_SACK:
          DBG_PL(ProcessChunk, "got SACK (CumAck=%d)!!"),
            ((SctpSackChunk_S *)ucpInChunk)->uiCumAck DBG_PR;

          ProcessSackChunk(ucpInChunk);

          /* Do we need to transmit a FORWARD TSN chunk??
           */
          if(uiAdvancedPeerAckPoint > uiCumAckPoint)
            eForwardTsnNeeded = TRUE;

          eSendNewDataChunks = TRUE;
          break; // no state change

        case SCTP_CHUNK_FORWARD_TSN:
          DBG_PL(ProcessChunk, "got FORWARD TSN (tsn=%d)!!"),
            ((SctpForwardTsnChunk_S *) ucpInChunk)->uiNewCum DBG_PR;

          ProcessForwardTsnChunk( (SctpForwardTsnChunk_S *) ucpInChunk );
          break; // no state change

        case SCTP_CHUNK_HB:
          DBG_PL(ProcessChunk, "got HEARTBEAT!!") DBG_PR;

          /* GenChunk() doesn't copy HB info
           */
          iThisOutDataSize = GenChunk(SCTP_CHUNK_HB_ACK, *ucppOutData);

          /* ...so we copy it here!
           */
          spHeartbeatChunk = (SctpHeartbeatAckChunk_S *) ucpInChunk;
          spHeartbeatAckChunk = (SctpHeartbeatAckChunk_S *) *ucppOutData;
          spHeartbeatAckChunk->dTimestamp = spHeartbeatChunk->dTimestamp;
          spHeartbeatAckChunk->spDest = spHeartbeatChunk->spDest;
          *ucppOutData += iThisOutDataSize;
          break; // no state change

        case SCTP_CHUNK_HB_ACK:
          DBG_PL(ProcessChunk, "got HEARTBEAT ACK!!") DBG_PR;
          ProcessHeartbeatAckChunk( (SctpHeartbeatAckChunk_S *) ucpInChunk);
          break; // no state change


//********************************************************************************
// Communications Protocols Laboratory(CPL) Kyungpook National University(KNU)
// Su-kyung's code
//********************************************************************************

        //jsk
        //process ASCONF chunk
        case SCTP_CHUNK_ASCONF:
          DBG_PL(ProcessChunk, "got ASCONF!!") DBG_PR;
          printf("%lf\n",Scheduler::instance().clock());
          printf("recv ASCONF\n");

          /* GenChunk() doesn't copy ASCONF info
           */
          iThisOutDataSize = GenChunk(SCTP_CHUNK_ASCONF_ACK, *ucppOutData);

          /* ...so we copy it here!
           */
          spAsconfChunk = (SctpAsconfAckChunk_S *) ucpInChunk;
          spAsconfAckChunk = (SctpAsconfAckChunk_S *) *ucppOutData;
          //spAsconfAckChunk->dTimestamp = spAsconfChunk->dTimestamp;
          spAsconfAckChunk->spDest = spAsconfChunk->spDest;  //why?????
          *ucppOutData += iThisOutDataSize;
        // printf("eState : %d\n",eState); 
        //printf("%lf\n",Scheduler::instance().clock());
        //  printf("recv ASCONF\n");
          break; // no state change

        case SCTP_CHUNK_ASCONF_ACK:
          DBG_PL(ProcessChunk, "got ASCONF ACK!!") DBG_PR;
          printf("%lf\n",Scheduler::instance().clock());
          ProcessAsconfAckChunk( (SctpAsconfAckChunk_S *) ucpInChunk);
          break; // no state change
        //


        case SCTP_CHUNK_INIT:
          DBG_PL(ProcessChunk, "unexpected chunk type (INIT) at %f"),
            dCurrTime DBG_PR;
          printf("[ProcessChunk] unexpected chunk type (INIT) at %f\n",
            dCurrTime);
          break;

        case SCTP_CHUNK_INIT_ACK:
          DBG_PL(ProcessChunk, "unexpected chunk type (INIT_ACK) at %f"),
            dCurrTime DBG_PR;
          printf("[ProcessChunk] unexpected chunk type (INIT_ACK) at %f\n",
            dCurrTime);
          break;

          /* even though the association is established, COOKIE_ECHO needs to be
           * handled because the peer may have not received the COOKIE_ACK.
           *
           * Note: we don't follow the rfc's complex process for handling this
           * case, because we don't deal with tie-tags, etc in simulation. :-)
           */
        case SCTP_CHUNK_COOKIE_ECHO:
          DBG_PL(ProcessChunk,
                 "got COOKIE_ECHO!! (established!) ...sending COOKIE_ACK")
            DBG_PR;
          ProcessCookieEchoChunk( (SctpCookieEchoChunk_S *) ucpInChunk);
          iThisOutDataSize = GenChunk(SCTP_CHUNK_COOKIE_ACK, *ucppOutData);
          *ucppOutData += iThisOutDataSize;
          break;

        case SCTP_CHUNK_COOKIE_ACK:
          DBG_PL(ProcessChunk, "unexpected chunk type (COOKIE_ACK) at %f"),
            dCurrTime DBG_PR;
          printf("[ProcessChunk] unexpected chunk type (COOKIE_ACK) at %f\n",
                 dCurrTime);
          break;

        default:
          ProcessOptionChunk(ucpInChunk);
          break;
        }
      break;

    case SCTP_STATE_UNINITIALIZED:
    case SCTP_STATE_SHUTDOWN_SENT:
    case SCTP_STATE_SHUTDOWN_RECEIVED:
    case SCTP_STATE_SHUTDOWN_ACK_SENT:
    case SCTP_STATE_SHUTDOWN_PENDING:
      break;
    }

  DBG_X(ProcessChunk);
  return iThisOutDataSize;
}

//void CwndDegradeTimer::expire(Event*)
//{
//  opAgent->CwndDegradeTimerExpiration(spDest);
//}



//********************************************************************************
// Communications Protocols Laboratory(CPL) Kyungpook National University(KNU)
// Su-kyung's code
//********************************************************************************

//jsk
int SctpHandoverAgent::SendAsconf(SctpDest_S *spDest)
{
        DBG_I(SendAsconf);
        DBG_PL(SendAsconf, "spDest=%p"), spDest DBG_PR;
        printf("%lf\n",Scheduler::instance().clock());

        printf("call Asconf\n");
        SctpAsconfChunk_S sAsconfChunk;

        GenChunk(SCTP_CHUNK_ASCONF,(u_char *) &sAsconfChunk); // doesn't fill dest
        sAsconfChunk.spDest = spDest;    //fill dest..
        SendPacket((u_char *) &sAsconfChunk, SCTP_CHUNK_ASCONF_LENGTH, spDest);
        printf("send ok\n");
        DBG_X(SendAsconf);
        return (TCL_OK);

}

