//********************************************************************************
// Communications Protocols Laboratory(CPL) Kyungpook National University(KNU)
// Su-kyung's code
//********************************************************************************

#ifndef ns_sctp_handover_h
#define ns_sctp_handover_h


#include "agent.h"
#include "node.h"
#include "packet.h"
#include "sctp.h"

#define SCTP_CHUNK_ASCONF_LENGTH 24
typedef struct SctpAsconfChunk_S
{
  SctpChunkHdr_S sHdr;
  u_int uiSeriNum;
  u_int uiAddrParam;

  u_short usType;
  u_short usLength;
  u_int uiAsconfReqCorID;

  u_int uiIpValue;
  SctpDest_S *spDest;
};

typedef SctpAsconfChunk_S SctpAsconfAckChunk_S;



class SctpHandoverAgent : public SctpAgent
{
public:
  
  SctpHandoverAgent(); 
  ~SctpHandoverAgent(){}
 
//virtual
//  void Timeout(SctpChunkType_E, SctpDest_S*);

  void SackGenTimerExpiration();

  protected:

//virtual
  int command(int argc, const char*const* argv);

//virtual
  int GenChunk(SctpChunkType_E eType, u_char *ucpChunk);
  int ProcessAsconfAckChunk(SctpAsconfAckChunk_S *spAsconfAckChunk);

//virtual
  int ProcessChunk(u_char *ucpInChunk, u_char **ucppOutData);
  int SendAsconf(SctpDest_S *spDest);
};

#endif
